<script src="@#file#(simplematrix.js)" type="text/javascript"></script>
<script src="@#file#(matrixprogram.js)" type="text/javascript"></script>

<script>
// convexPolygonFiller: function for filling convex poligon area while interpolating colors
// data: {
//  vertices: [[x,y],[x,y],[x,y],...]
//  colors:   [[r,g,b],[r,g,b],[r,g,b],...]
//}
function convexPolygonFiller(ctx, data) {
  function lerp(sc, ec, y, ymin, ymax) {
    let t = (y-ymin)/(ymax-ymin);
    return [
      sc[0]*(1-t) + ec[0]*t,
      sc[1]*(1-t) + ec[1]*t,
      sc[2]*(1-t) + ec[2]*t
    ];
  }
  function tohex(rgb) {
    var c1 = Math.round(rgb[0]).toString(16);
    var c2 = Math.round(rgb[1]).toString(16);
    var c3 = Math.round(rgb[2]).toString(16);
    if(c1.length<2) c1 = "0"+c1;
    if(c2.length<2) c2 = "0"+c2;
    if(c3.length<2) c3 = "0"+c3;
    return c1+c2+c3;
  }
  function isclockwise() {
    let yes = 0, no = 0;
    for(let i = 0; i < data.vertices.length; i++) {
      let j = (i+1) % data.vertices.length;
      let k = (i+2) % data.vertices.length;
      let x0 = data.vertices[i][0];
      let y0 = data.vertices[i][1];
      let x1 = data.vertices[j][0];
      let y1 = data.vertices[j][1];
      let x2 = data.vertices[k][0];
      let y2 = data.vertices[k][1];
      let a = -(y1-y0);
      let b = x1-x0;
      let c = x0*(y1-y0)-y0*(x1-x0);
      let test = a*x2 + b*y2 + c;
      if(Math.abs(test)<1E-6) continue;
      if(test>0) { yes++; } else { no++; }
    }
    return yes>no;
  }
  let cw = isclockwise();
  let fs = ctx.fillStyle;
  let edges = [];
  let numleft = 0, numright=0;
  let xmin = 0, xmax = 0, ymin = 0, ymax = 0;
  for(let i = 0; i < data.vertices.length; i++) {
    let j = (i+1) % data.vertices.length;
    let x0 = data.vertices[i][0];
    let y0 = data.vertices[i][1];
    let x1 = data.vertices[j][0];
    let y1 = data.vertices[j][1];
    if(i==0) {
      xmin = x0; xmax = x0;
      ymin = y0; ymax = y0;
    } else {
      xmin = Math.min(xmin,x0); xmax = Math.max(xmax,x0);
      ymin = Math.min(ymin,y0); ymax = Math.max(ymax,y0);
    }
    if(Math.abs(y1-y0) < 0.1) continue;
    let isleft = cw ? y0 > y1 : y1 > y0;
    if(isleft) { numleft++; } else { numright++; }
    edges.push({
      a: -(y1-y0),
      b: x1-x0,
      c: x0*(y1-y0)-y0*(x1-x0),
      lowerColor: isleft?data.colors[i]:data.colors[j],
      upperColor: isleft?data.colors[j]:data.colors[i],
      isleft: isleft,
      lowerVertex: isleft?data.vertices[i]:data.vertices[j],
      upperVertex: isleft?data.vertices[j]:data.vertices[i]
    });
  }
  if(numleft==0 || numright==0) return;
  for(let y = ymin; y <= ymax; y++) {
    let l = xmin-5, r = xmax+5, li = 0, ri = 0;
    for(let ei = 0; ei < edges.length; ei++) {
      let edge = edges[ei];
      let x = (-edge.b*y-edge.c)/edge.a;
      if(edge.isleft) {
        if(x>l) { l = x; li = ei; }
      } else {
        if(x<r) { r = x; ri = ei; }
      }
    }
    if(l<=r) {
      let rgb1 = lerp(edges[li].lowerColor, edges[li].upperColor, y, edges[li].lowerVertex[1], edges[li].upperVertex[1]);
      let rgb2 = lerp(edges[ri].lowerColor, edges[ri].upperColor, y, edges[ri].lowerVertex[1], edges[ri].upperVertex[1]);
      let gradient = ctx.createLinearGradient(l, y, r, y);
      let startColor = "rgb("+rgb1[0]+","+rgb1[1]+","+rgb1[2]+")";
      let endColor   = "rgb("+rgb2[0]+","+rgb2[1]+","+rgb2[2]+")";
      gradient.addColorStop(0, startColor);
      gradient.addColorStop(1, endColor);
      ctx.fillStyle = gradient;
      ctx.fillRect(l, y, r-l+1, 1);
    }
  }
  ctx.fillStyle = fs;
}

function GridDisplay(canvasID, xmin, xmax, ymin, ymax) {
  this.canvas = document.getElementById(canvasID);
  this.context = this.canvas.getContext("2d");
  this.objects = [];
  this.objData = {
    objdefault: {
      draw: function(ctx, tr) {
        let v1 = new matrix([[0,0,1]]).mul(tr).divByLastColumn();
        let v2 = new matrix([[1,0,1]]).mul(tr).divByLastColumn();
        let v3 = new matrix([[1,1,1]]).mul(tr).divByLastColumn();
        let v4 = new matrix([[0,1,1]]).mul(tr).divByLastColumn();

        convexPolygonFiller(ctx,{vertices: [
           [v1.data[0][0],v1.data[0][1]],
           [v4.data[0][0],v4.data[0][1]],
           [v3.data[0][0],v3.data[0][1]],
           [v2.data[0][0],v2.data[0][1]]
          ], colors: [
           [255,0,0],
           [0,255,0],
           [0,0,255],
           [255,255,255]
          ]});

        ctx.fillStyle = "#ffffee";
        ctx.strokeStyle = "#FF0000";
        ctx.beginPath();
        ctx.moveTo(v1.data[0][0],v1.data[0][1]);
        ctx.lineTo(v2.data[0][0],v2.data[0][1]);
        ctx.lineTo(v3.data[0][0],v3.data[0][1]);
        ctx.lineTo(v4.data[0][0],v4.data[0][1]);
        ctx.lineTo(v1.data[0][0],v1.data[0][1]);
        ctx.stroke();
      }
    }
  };

  this.paint = function() {
    this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
    this.context.fillStyle = "#ffffee";
    this.context.strokeStyle = "#aaaa00";
    let w = this.canvas.width;
    let h = this.canvas.height;
    let dw = xmax-xmin;
    let dh = ymax-ymin;
    let trf = new matrix([[(w-1)/dw, 0,0],[0, -(h-1)/dh,0],[-xmin*(w-1)/dw,ymax*(h-1)/dh,1]]);
    let xleft = (new matrix([[xmin,0,1]])).mul(trf);
    let xright = (new matrix([[xmax,0,1]])).mul(trf);
    let ytop = (new matrix([[0,ymax,1]])).mul(trf);
    let ybottom = (new matrix([[0,ymin,1]])).mul(trf);
    let origin = (new matrix([[0,0,1]])).mul(trf);

    for(let x = xmin; x <= xmax; x++) {
      let p1 = (new matrix([[x,0,1]])).mul(trf);
      this.context.beginPath();
      this.context.moveTo(p1.data[0][0],ytop.data[0][1]);
      this.context.lineTo(p1.data[0][0],ybottom.data[0][1]);
      this.context.stroke();
    }
    for(let y = ymin; y <= ymax; y++) {
      let p1 = (new matrix([[0,y,1]])).mul(trf);
      this.context.beginPath();
      this.context.moveTo(xleft.data[0][0],p1.data[0][1]);
      this.context.lineTo(xright.data[0][0],p1.data[0][1]);
      this.context.stroke();
    }
    if(xmin <= 0 && xmax >= 0) {
      this.context.lineWidth = 3;
      this.context.beginPath();
      this.context.moveTo(origin.data[0][0],ytop.data[0][1]);
      this.context.lineTo(origin.data[0][0],ybottom.data[0][1]);
      this.context.stroke();
      this.context.lineWidth = 1;
    }
    if(ymin <= 0 && ymax >= 0) {
      this.context.lineWidth = 3;
      this.context.beginPath();
      this.context.moveTo(xleft.data[0][0],origin.data[0][1]);
      this.context.lineTo(xright.data[0][0],origin.data[0][1]);
      this.context.stroke();
      this.context.lineWidth = 1;
     }
     for(let i = 0; i < this.objects.length; i++) {
       let obj = this.objects[i];
       let objdef = this.objData["obj"+obj.name];
       objdef.draw(this.context, obj.matrix.mul(trf));
     }
  }
}

function progtakeydown(event) {
  if(event.keyCode == 13 && event.ctrlKey) {
    compileActiveProgram(true,true);
  }
}
</script>
  <p>Za kraj minilekcije, evo jednog zadatka koji će Vam pomoći utvrditi uporabu prethodno 
     pojašnjenih transformacija.</p>

  <p>Na sljedećoj slici prikazano je 9 likova. Svaki lik nastao je crtanjem jediničnog kvadrata
     čiji su vrhovi (0,0): crveni, (0,1):zeleni, (1,1): plavi te (1,0): bijeli, na način da su mu
     svi vrhovi prije crtanja transformirani određenom matricom. Pri tome je korištena konvencija
     množenja točke s matricom (t'=t*M).</p>

  <p>Koordinatni sustav je matematički: ishodište je u centru; x-os je raspona -10 do 10, y-os je raspona
     -10 do 10. Osi su prikazane podebljano.</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas0" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var brcanvas0 = new GridDisplay("myCanvas0", -10, 10, -10, 10);
    brcanvas0.objects.push({
      matrix: new matrix([[1,0,0],[0,1,0],[8, 5, 1]]),
      text: "matrix = [1, 0, 0|0, 1, 0|8, 5, 1]",
      name: "default",
      objid: 1
    });
    brcanvas0.objects.push({
      matrix: new matrix([[2,0,0],[0,2,0],[-8,5,1]]),
      text: "matrix = [2, 0, 0|0, 2, 0|-8, 5, 1]",
      name: "default",
      objid: 2
    });
    brcanvas0.objects.push({
      matrix: new matrix([[0.5, -0.5, 0],[0.5, 0.5, 0],[-5, 2.5, 1]]),
      text: "matrix = [0.5, -0.5, 0|0.5, 0.5, 0|-5, 2.5, 1]",
      name: "default",
      objid: 3
    });
    brcanvas0.objects.push({
      matrix: new matrix([[0.5, 0.5, 0],[-0.5, 0.5, 0],[-6.5, 2, 1]]),
      text: "matrix = [0.5, 0.5, 0|-0.5, 0.5, 0|-6.5, 2, 1]",
      name: "default",
      objid: 4
    });
    brcanvas0.objects.push({
      matrix: new matrix([[-1, -1, 0],[1, -1, 0],[-6.5, 1.5, 1]]),
      text: "matrix = [-1, -1, 0|1, -1, 0|-6.5, 1.5, 1]",
      name: "default",
      objid: 5
    });
    brcanvas0.objects.push({
      matrix: new matrix([[3, 0, 0],[1.5, 3, 0],[3, -8, 1]]),
      text: "matrix = [3, 0, 0|1.5, 3, 0|3, -8, 1]",
      name: "default",
      objid: 6
    });
    brcanvas0.objects.push({
      matrix: new matrix([[-2, 0, 0],[0, 2, 0],[-5, -7, 1]]),
      text: "matrix = [-2, 0, 0|0, 2, 0|-5, -7, 1]",
      name: "default",
      objid: 7
    });
    brcanvas0.objects.push({
      matrix: new matrix([[3, 1.5, 0],[1.5, 3, 0],[-1, 3, 1]]),
      text: "matrix = [3, 1.5, 0|1.5, 3, 0|-1, 3, 1]",
      name: "default",
      objid: 8
    });
    brcanvas0.objects.push({
      matrix: new matrix([[3, 0, 0],[0, 1, 0],[5, -2, 1]]),
      text: "matrix = [2, 0, 0|0, 0.5, 0|-7, -3, 1]",
      name: "default",
      objid: 9
    });
    brcanvas0.paint();
  </script>

  <p>U nastavku je prikazano prazno platno na kojem nema još niti jednog lika. Klikom na gumb
     "Dodaj" možete dodavati kvadrate. Svaki novi kvadrat bit će inicijalno povezan s jediničnom
     matricom koja će biti prikazana u kutiji za unos teksta ispod. Vaš je zadatak dodavati
     kvadrat po kvadrat te za svaki kvadrat definirati prikladnu transformacijsku matricu kako biste
     kvadrat poklopili s jednim od onih prikazanih na prvoj slici.</p>

  <p>Nakon što u kutiji za unos promijenite matricu, pritiskom na CTRL+ENTER ažurirat će se prikazana
     slika (u slučaju pogrešaka, iste će biti ispisane). Za svaki dodani objekt pojavit će se i jedna
     stavka u listi ispod slike. Klikom na stavku aktivirat ćete taj objekt (njegova matrica prikazat 
     će se u kutiji za unos teksta). Više o podržanoj sintaksi dostupno je u pomoći ispod.</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var brcanvas = new GridDisplay("myCanvas", -10, 10, -10, 10);
    brcanvas.paint();
  </script>

  <br>
  <textarea id="progta" rows="5" cols="120" onkeydown="progtakeydown(event)"></textarea><br>
  <div id="proglog"></div>

<button onclick="compileActiveProgram(true,false); return false;">Primijeni matricu</button>

<ul id="listax">
</ul>

<script>

function compileActiveProgram(updatecanvas,rethrow) {
  function findObj(k) {
    let obj = null;
    for(let i = 0; i < brcanvas.objects.length; i++) {
      if(brcanvas.objects[i].objid==k) { obj = brcanvas.objects[i]; break; }
    }
    return obj;
  }
  if(activeObjIndex==null) return;
  let prevObj = findObj(activeObjIndex);
  if(prevObj != null) {
    prevObj.text = document.getElementById("progta").value;
    let parser = null;
    let v = null;
    try {
      parser = new matprogparser(prevObj.text);
      v = new matrixprogramEvalVisitor();
      parser.dom.acceptVisitor(v);
    } catch(err) {
      document.getElementById("proglog").innerHTML = err;
      if(rethrow) throw err;
      return;
    }
    if(!v.names.has("matrix")) {
      document.getElementById("proglog").innerHTML = "Program ne sadrži varijablu imena matrix!";
      return;
    }
    document.getElementById("proglog").innerHTML = "";
    prevObj.matrix = v.getValue("matrix").vvalue;
    if(updatecanvas) brcanvas.paint();
  }
}

function obradiKlik(n) {
  function findObj(k) {
    let obj = null;
    for(let i = 0; i < brcanvas.objects.length; i++) {
      if(brcanvas.objects[i].objid==k) { obj = brcanvas.objects[i]; break; }
    }
    return obj;
  }
  let nextObj = findObj(n);
  if(nextObj!=null) {
    compileActiveProgram(false,true);
    activeObjIndex = n;
    document.getElementById("progta").value = nextObj.text;
    brcanvas.paint();
  }
}

var activeObjIndex = null;
var objIndex = 0;
function dodajObjekt() {
  let lista = document.getElementById("listax");
  let li = document.createElement("li");
  objIndex++;
  li.setAttribute("data-objIndex", objIndex);
  li.setAttribute("onclick", "obradiKlik("+objIndex+")");
  li.appendChild(document.createTextNode("objekt "+objIndex));
  lista.appendChild(li);
  let obj = {
    matrix: new matrix([[1,0,0],[0,1,0],[0,0,1]]),
    text: "matrix = [1,0,0|0,1,0|0,0,1]",
    name: "default",
    objid: objIndex
  };
  brcanvas.objects.push(obj);
  document.getElementById("progta").value = obj.text;
  activeObjIndex = objIndex;
  brcanvas.paint();
}
</script>

<button onclick="dodajObjekt(); return false;">Dodaj objekt</button>

  <p style="font-weight: bold;">Pomoć</p>

  <p>Unesena matrica mora biti dimenzija 3x3 (radimo u 2D u homogenom prostoru). Matrice se zbrajaju,
     oduzimaju odnosno množe operatorima <code>+</code>, <code>-</code> i <code>*</code>. Na mjestu 
     skalara možete pisati aritmetičke izraze te koristiti funkcije <code>sin</code>, <code>cos</code>, 
     <code>tan</code> i <code>sqrt</code>.
  </p>
  <p>Dostupne su i funkcije koje generiraju matrice i koje možete također koristiti u izrazima:
     <code>translate2d(dx,dy)</code>, <code>scale2d(sx,sy)</code>, <code>rotate2d(kut)</code> (kut je
     u stupnjevima). Inverz matrice se dobiva s <code>.inverse</code>, matrica se transponira dodavanjem 
     <code>.transpose</code>.
  </p>
  <p>Iako se svi primjeri mogu riješiti definiranjem samo jednog izraza za varijablu <code>matrix</code>, 
     dozvoljeno je definirati i pomoćne varijable pa ih potom koristiti. Npr. sljedeći primjer je legalan program.
  </p>
  <pre>m1 = translate2d(-4,2+sqrt(3))
m2 = scale2d(0.5,4)
matrix = m1 * m2.inverse
  </pre>

